"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function zeroFill(data) {
  return data < 10 ? "0".concat(data) : data;
}

function secToMin(seconds) {
  return "".concat(zeroFill(parseInt(seconds / 60, 10)), ":").concat(zeroFill(seconds % 60));
}

var Countdown = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Countdown, _React$PureComponent);

  var _super = _createSuper(Countdown);

  function Countdown(props) {
    var _this;

    _classCallCheck(this, Countdown);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "startTimer", function (count) {
      _this.intervalId = setInterval(function () {
        count--;

        if (count > 0) {
          _this.setState({
            tip: _this.renderTip(count)
          });
        } else {
          _this.setState({
            tip: ''
          });

          clearInterval(_this.intervalId);

          if (_this.props.onComplete) {
            _this.props.onComplete();
          }
        }
      }, 1000);
    });

    _defineProperty(_assertThisInitialized(_this), "renderTip", function (count) {
      var _this$props = _this.props,
          type = _this$props.type,
          prefix = _this$props.prefix,
          suffix = _this$props.suffix;

      if (count <= 0) {
        return '';
      }

      var result;

      switch (type) {
        case 'normal':
          result = count;
          break;

        case 'hour':
          result = "".concat(secToMin(count));
          break;

        default:
          result = count;
      }

      return "".concat(prefix).concat(result).concat(suffix);
    });

    _this.state = {
      tip: _this.renderTip(_this.props.count)
    };
    return _this;
  }

  _createClass(Countdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var count = this.props.count;

      if (count > 0) {
        this.startTimer(count);
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.intervalId) {
        clearInterval(this.intervalId);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          className = _this$props2.className,
          style = _this$props2.style;
      var tip = this.state.tip;

      if (tip === '') {
        return null;
      }

      return /*#__PURE__*/_react["default"].createElement("span", {
        className: className,
        style: style
      }, tip);
    }
  }]);

  return Countdown;
}(_react["default"].PureComponent);

exports["default"] = Countdown;

_defineProperty(Countdown, "propTypes", {
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  count: _propTypes["default"].number,
  type: _propTypes["default"].string,
  prefix: _propTypes["default"].string,
  suffix: _propTypes["default"].string,
  onComplete: _propTypes["default"].func
});

_defineProperty(Countdown, "defaultProps", {
  style: {},
  className: '',
  count: 0,
  type: 'normal',
  prefix: '',
  suffix: ''
});