"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _getPrefixCls = _interopRequireDefault(require("../../utils/getPrefixCls"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function noop() {}

var Pagination = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Pagination, _React$PureComponent);

  var _super = _createSuper(Pagination);

  function Pagination() {
    var _this;

    _classCallCheck(this, Pagination);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      current: _this.props.current || 1,
      // 当前页数
      pageSize: _this.props.pageSize || 10,
      // 每页条数
      jumpPage: '' // 跳转页

    });

    _defineProperty(_assertThisInitialized(_this), "handleJump", function (e) {
      if (e.keyCode === 13) {
        // Enter键
        _this.setState({
          jumpPage: ''
        });

        var jumpPage = _this.state.jumpPage;

        if (/^\d+$/.test(jumpPage) && Number(jumpPage) > 0) {
          _this.handleChange(Number(jumpPage));
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "onJumperChange", function (e) {
      _this.setState({
        jumpPage: e.target.value
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onPageSizeChange", function (e) {
      var pageSize = Number(e.target.value);
      var current = 1;

      if (!('current' in _this.props)) {
        _this.setState({
          current: current
        });
      }

      if (!('pageSize' in _this.props)) {
        _this.setState({
          pageSize: pageSize
        });
      }

      _this.props.onChange(current, pageSize);
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function (page) {
      if (!('current' in _this.props)) {
        _this.setState({
          current: page
        });
      }

      _this.props.onChange(page, _this.state.pageSize);
    });

    _defineProperty(_assertThisInitialized(_this), "prev", function () {
      if (!_this.props.disabled && _this.hasPrev()) {
        _this.handleChange(_this.state.current - 1);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "next", function () {
      if (!_this.props.disabled && _this.hasNext()) {
        _this.handleChange(_this.state.current + 1);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "hasPrev", function () {
      return _this.state.current > 1;
    });

    _defineProperty(_assertThisInitialized(_this), "hasNext", function () {
      // 当前页数据总数>=每页条数，将有下一页
      return _this.props.dataSize >= _this.state.pageSize;
    });

    return _this;
  }

  _createClass(Pagination, [{
    key: "getPageSizeOptions",
    value: function getPageSizeOptions() {
      var pageSize = this.state.pageSize;
      var pageSizeOptions = this.props.pageSizeOptions;

      if (pageSizeOptions.some(function (option) {
        return option.toString() === pageSize.toString();
      })) {
        return pageSizeOptions;
      }

      return pageSizeOptions.concat([pageSize.toString()]).sort(function (a, b) {
        var numberA = Number.isNaN(Number(a)) ? 0 : Number(a);
        var numberB = Number.isNaN(Number(b)) ? 0 : Number(b);
        return numberA - numberB;
      });
    } // 跳转至某页

  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          prefixCls = _this$props.prefixCls,
          showQuickJumper = _this$props.showQuickJumper,
          showSizeChanger = _this$props.showSizeChanger,
          style = _this$props.style,
          className = _this$props.className,
          disabled = _this$props.disabled;
      var _this$state = this.state,
          current = _this$state.current,
          pageSize = _this$state.pageSize;
      var prevDisabled = disabled || !this.hasPrev(); // 上一页禁用

      var nextDisabled = disabled || !this.hasNext(); // 下一页禁用

      var changeSelect = null;

      if (showSizeChanger) {
        var pageSizeOptions = this.getPageSizeOptions();
        changeSelect = /*#__PURE__*/_react["default"].createElement("li", {
          className: "".concat(prefixCls, "-options")
        }, /*#__PURE__*/_react["default"].createElement("select", {
          value: pageSize,
          onChange: this.onPageSizeChange,
          disabled: disabled,
          "aria-disabled": disabled
        }, pageSizeOptions.map(function (el) {
          return /*#__PURE__*/_react["default"].createElement("option", {
            value: el,
            key: el
          }, el, "\u6761/\u9875");
        })));
      }

      return /*#__PURE__*/_react["default"].createElement("ul", {
        className: (0, _classnames["default"])(prefixCls, className),
        style: style,
        unselectable: "unselectable"
      }, /*#__PURE__*/_react["default"].createElement("li", {
        className: "".concat(prefixCls, "-page")
      }, "\u9875\u7801:", ' ', current), /*#__PURE__*/_react["default"].createElement("li", {
        className: "".concat(prevDisabled ? "".concat(prefixCls, "-disabled ") : '').concat(prefixCls, "-prev"),
        onClick: this.prev,
        "aria-disabled": prevDisabled
      }, "\u4E0A\u4E00\u9875"), /*#__PURE__*/_react["default"].createElement("li", {
        className: "".concat(nextDisabled ? "".concat(prefixCls, "-disabled ") : '').concat(prefixCls, "-next"),
        onClick: this.next,
        "aria-disabled": nextDisabled
      }, "\u4E0B\u4E00\u9875"), changeSelect, showQuickJumper && /*#__PURE__*/_react["default"].createElement("li", {
        className: "".concat(prefixCls, "-jumper")
      }, "\u8DF3\u81F3", /*#__PURE__*/_react["default"].createElement("input", {
        type: "text",
        value: this.state.jumpPage,
        onChange: this.onJumperChange,
        onKeyDown: this.handleJump,
        disabled: disabled,
        "aria-disabled": disabled
      }), "\u9875"));
    }
  }], [{
    key: "getDerivedStateFromProps",
    value: function getDerivedStateFromProps(props, state) {
      var newState = {};

      if ('current' in props && props.current !== state.current) {
        newState.current = props.current;
      }

      if ('pageSize' in props && props.pageSize !== state.pageSize) {
        newState.pageSize = props.pageSize;
      }

      return newState;
    }
  }]);

  return Pagination;
}(_react["default"].PureComponent);

exports["default"] = Pagination;

_defineProperty(Pagination, "propTypes", {
  style: _propTypes["default"].object,
  prefixCls: _propTypes["default"].string,
  className: _propTypes["default"].string,
  current: _propTypes["default"].number,
  pageSize: _propTypes["default"].number,
  dataSize: _propTypes["default"].number.isRequired,
  onChange: _propTypes["default"].func,
  disabled: _propTypes["default"].bool,
  showQuickJumper: _propTypes["default"].bool,
  showSizeChanger: _propTypes["default"].bool,
  pageSizeOptions: _propTypes["default"].arrayOf(_propTypes["default"].string)
});

_defineProperty(Pagination, "defaultProps", {
  prefixCls: (0, _getPrefixCls["default"])('pagination'),
  style: {},
  className: '',
  disabled: false,
  showQuickJumper: false,
  showSizeChanger: false,
  pageSizeOptions: ['10', '20', '30', '40'],
  // 默认指定每页可以显示条数
  onChange: noop
});